Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa31.bas
'
'       AISA-P31 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Errors

Global Const AISA31_SUCCESS = 0                ' ُȂ
Global Const AISA31_ERR_SYSTEM = 1             ' GetLastError sĂ
Global Const AISA31_ERR_NO_DEVICE = 2          ' gp\ȃfoCXȂ
Global Const AISA31_ERR_IN_USE = 3             ' w肳ꂽۯĂ͎gp
Global Const AISA31_ERR_INVALID_SLOT = 4       ' ȁi_jۯĔԍ
Global Const AISA31_ERR_RESOURCE = 5           ' \[XG[
Global Const AISA31_ERR_INVALID_PORT = 6       ' ȃ|[gԍ
Global Const AISA31_ERR_INVALID_ARGUMENT = 7   ' Ȉ

' Port numbers

Global Const AISA31_PORT_1 = 0
Global Const AISA31_PORT_2 = 1
Global Const AISA31_PORT_3 = 2
Global Const AISA31_PORT_4 = 3

' Miscellaneous

Global Const AISA31_MAX_SLOTS = 16             ' Maximum number of slots

Global Const AISA31_SLOT_AUTO = &HFFFF

' Device ID

Global Const AISA31_DEVICE_ID = &H5031

' Resource infomation structure

Global Const AISA31_MAX_MEM = 9
Global Const AISA31_MAX_IO = 20
Global Const AISA31_MAX_IRQ = 7
Global Const AISA31_MAX_DMA = 7

Type AISA31RESOURCE
    dwNumMemWindows As Long                         ' س޳       gp
    dwMemBase(1 To AISA31_MAX_MEM) As Long          ' س޳ްڽgp
    dwMemLength(1 To AISA31_MAX_MEM) As Long        ' س޳       gp
    dwMemAttrib(1 To AISA31_MAX_MEM) As Long        ' س޳     gp
    dwNumIOPorts As Long                            ' I/O߰Đ
    dwIOPortBase(1 To AISA31_MAX_IO) As Long        ' I/O߰ްڽ
    dwIOPortLength(1 To AISA31_MAX_IO) As Long      ' I/O߰Ē
    dwNumIRQs As Long                               ' IRQ             gp
    dwIRQRegisters(1 To AISA31_MAX_IRQ) As Long     ' IRQؽ            gp
    dwIRQAttrib(1 To AISA31_MAX_IRQ) As Long        ' IRQؽ        gp
    dwNumDMAs As Long                               ' DMAِ         gp
    dwDMALst(1 To AISA31_MAX_DMA) As Long           ' DMAؽ        gp
    dwDMAAttrib(1 To AISA31_MAX_DMA) As Long        ' DMAّؽ    gp
    dwReserved1(1 To 3) As Long                     ' \              gp
End Type

Declare Function Aisa31GetVersion Lib "aisa31" (pdwDllVer As Long, pdwDrvVer As Long) As Long
Declare Function Aisa31Create Lib "aisa31" (pwLogSlot As Integer) As Long
Declare Function Aisa31Close Lib "aisa31" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa31GetResource Lib "aisa31" (ByVal wLogSlot As Integer, pRes As AISA31RESOURCE) As Long
Declare Function Aisa31InPort Lib "aisa31" (ByVal wLogSlot As Integer, ByVal dwPort As Long, pbValue As Byte) As Long
Declare Function Aisa31OutPort Lib "aisa31" (ByVal wLogSlot As Integer, ByVal dwPort As Long, ByVal bValue As Byte) As Long
Declare Function Aisa31GetLastError Lib "aisa31" (ByVal wLogSlot As Integer) As Long
